
<template>
<el-container class="mainContainer">

  <el-aside width="200px">
    <TheMenu />
  </el-aside>

  <el-container>

    <el-header height="60px">
      <TheTopTask 
        ref="TheTopTask"
      />
    </el-header>

    <el-main>
      <router-view></router-view>
    </el-main>
  </el-container>
</el-container>
</template>

<script>
  import TheMenu from './components/TheMenu.vue'
  import TheTopTask from './components/TheTopTask.vue'
  import { mapActions, mapMutations, mapState } from 'vuex';

  export default {
    components : {
      TheMenu, TheTopTask
    },
    methods: {
      ... mapMutations({
        SET_NOTIFIER: 'notifications/SET_NOTIFIER'
      }),
      ... mapActions({
        fetchAllTasks: 'tasks/fetchAllTasks',
        updateAllTasks: 'tasks/updateAllTasks',
        error: 'notifications/error',
      }),
    },
    watch: {
      tasks : {
        deep : true,
        async handler(newVal, OldVal) {
          if(newVal === null && OldVal === null)
            return;
          try {
            await this.updateAllTasks()
          } catch (error) {
            this.error({
              title: 'Mode hors-ligne',
              message: 'Synchronisation des tâches impossible'
            })
          }
        }
        
      }
    },
    computed: {
      ... mapState({
        tasks : (state) => state.tasks.tasks
      }),
    },
    async created () {
      this.SET_NOTIFIER(this.$notify)
      try {
        await this.fetchAllTasks()
      } catch (error) {
        this.error({
          title: 'Mode hors-ligne',
          message: 'Récuperation des tâches impossible'
        })
      }
    },
  }
</script>

<style lang="scss">
  body {
    margin: 0;
    font-family: Avenir, Helvetica, Arial, sans-serif;
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
  }

  #app {
    position: absolute;
    top: 0;
    left: 0;
    bottom: 0;
    right: 0;
    text-align: center;
    color: #2c3e50; 
  }

  .el-header {
    color: var(--el-text-color-primary);
    line-height: 60px;
    padding: 0;
    border-bottom: solid 1px #e6e6e6;
    .el-input .el-input__inner {
      border: none;
    }
  }

  .mainContainer {
    height: 1000%;
  }
  
  .el-aside {
    color: var(--el-text-color-primary);
    border-right: solid 1px #e6e6e6;
  }

  tr.highlight-line td {
    background-color: #3997f531 !important;
  }
</style>
